/*
*********************************************************************************************************
*                                               uC/OS-II
*                                        The Real-Time Kernel
*
*                        (c) Copyright 1992-1998, Jean J. Labrosse, Plantation, FL
*                                          All Rights Reserved
*
*                                       TI TMS320C5409 Specific code
*                                          
*
* File : OS_CPU.H
* By   : Yi Han
*********************************************************************************************************
*/

#ifdef  OS_CPU_GLOBALS
#define OS_CPU_EXT
#else
#define OS_CPU_EXT  extern
#endif

/*
*********************************************************************************************************
*                                              DATA TYPES
*                                         (Compiler Specific)
*********************************************************************************************************
*/

typedef unsigned int  BOOLEAN;
typedef unsigned int  INT8U;                    /* Unsigned  8 bit quantity, but on C549 it is actually 16 bit */
typedef signed   int  INT8S;                    /* Signed    8 bit quantity, but on C549 it is actually 16 bit */
typedef unsigned int  INT16U;                   /* Unsigned 16 bit quantity                           */
typedef signed   int  INT16S;                   /* Signed   16 bit quantity                           */
typedef unsigned long  	      INT32U;                   /* Unsigned 32 bit quantity                           */
typedef long  	      INT32S;                   /* Signed   32 bit quantity                           */
typedef float         FP32;                     /* Single precision floating point                    */
typedef double        FP64;                     /* Double precision floating point                    */

typedef unsigned int   OS_STK;                   /* Each stack entry is 16-bit wide                    */

#define BYTE           INT8S                     /* Define data types for backward compatibility ...   */
#define UBYTE          INT8U                     /* ... to uC/OS V1.xx.  Not actually needed for ...   */
#define WORD           INT16S                    /* ... uC/OS-II.                                      */
#define UWORD          INT16U
#define LONG           INT32S
#define ULONG          INT32U

/* 
*********************************************************************************************************
*                              TI TMS320C5409
*********************************************************************************************************
*/

#define  OS_ENTER_CRITICAL()  asm(" ssbx INTM")       /* Disable interrupts                            */
#define  OS_EXIT_CRITICAL()   asm(" rsbx INTM")       /* Enable  interrupts                            */

/*
*********************************************************************************************************
*                           TI TMS320C5409 Miscellaneous
*********************************************************************************************************
*/

#define  OS_STK_GROWTH        1                       /* Stack grows from HIGH to LOW memory on C549  */

#define  OS_TASK_SW()         asm(" INTR #2")		/* use soft interrupt17 to do context switch */

/*
*********************************************************************************************************
*                                            GLOBAL VARIABLES
*********************************************************************************************************
*/

//OS_CPU_EXT  INT8U  OSTickDOSCtr;       /* Counter used to invoke DOS's tick handler every 'n' ticks    */
