MEMORY                      /* TMS320C54x microprocessor mode memory map     */
{
  PAGE 0 :
    PROG:       origin = 0x2400, length = 0x5b80   /* code */
    VECTORS:    origin = 0x7F80, length = 0x80     /* interrupt vector table */

  PAGE 1 : 
    DARAM:      origin = 0x0080, length = 0x1f80   /* data buffer, 8064 words*/
    STACK:      origin = 0x2000, length = 0x400    /* stack, 1024 words*/
}

SECTIONS
{
/* C definition */
    .text       : load = PROG     page 0 /*executable code*/
    .cinit      : load = PROG     page 0 /*tables for initializing variables and constants*/
    .switch     : load = PROG     page 0 /*tables for switch statement */
    .const      : load = DARAM    page 1 /*data defined as C qualifier const */
    .bss        : load = DARAM    page 1 /*global and static variables*//*WAB 3/19/90 */
    .stack      : load = STACK    page 1 /*C system stack*/
    .coeff      : load = DARAM    page 1 /*.h file*/

/* ASM definition */
    .vectors                   : >VECTORS    page 0 /*interrupt vector table */
    .daram_buffers             : >DARAM      page 1 /*global data buffers */
    .data                      : >DARAM      page 1 /*.dat files*/
    .control_variables         : >DARAM      page 1 /*global data variables */
}

